# UNOFFICIAL Crossfire Windows Client

    WARNING! This software is NOT SUPPORTED and NOT ENDORSED
             by the official Crossfire project or Crossfire 
             developers!

This is a game client for **Crossfire: The Multiplayer Adventure Game**

**Official** clients can be found at:
- http://crossfire.real-time.com/clients/index.html

More information about Crossfire:
- http://crossfire.real-time.com
- https://sourceforge.net/projects/crossfire/

How to Play Crossfire:
- http://crossfire.real-time.com/guides/
- http://crossfire.real-time.com/guides/handbook/index.html

## History of this project
I first found Crossfire around 2009, and played for quite some time on a private server. Recently, I came back to play again after a number of years of not playing, and found the game and interface wasn't super friendly to new players. All in all, I found the interface and control schemes pretty confusing with the mix of a GUI and text commands.

I remembered I wanted to write my own client back in 2009 just to see if I could, and lately I felt that I needed a new project project, so I figured I'd try to come up with something that might be a little easier to use for new or beginner players.

-Cloak

## Notable Features
- More Accessible - I think - for new / returning players
	- Adheres more to Windows UI standards compared to other clients
	- Consistent UX throughout the application
	- Mouse friendly interface, with right click context menus for actions and command help
	- Each dockable window has a context menu with related options and actions (Accessible via right click on the title or via down arrow in toolbar)
- Utilizes a Dockable Window System
	- Windows are movable, dockable, floatable, and rearrangeable on the fly
	- Support for multiple saved window layouts (global, per character, and custom)
	- Layouts are switchable via keybinds or when characters are loaded
- Completely Theme-able
	- Background/Foreground colours, font styles and sizes are changeable on the fly
	- Each dockable window provides additional customization, eg:
		- Inventory item colours and display can be changed based on item info
		- Message colors can be overridden based on category
		- Row heights and icon sizes can be changed in listboxes
		- List views can be sorted, grouped, and support multiple view types (details, icon, etc)
- Other minor but useful changes
	- Open containers pop up a new inventory window to display their contents
	- Map window scales to screen and is easily zoomable
	- Message window display can be zoomed in or out
	- Can hide or show any window via keybinds
	- Hotkey bar
	- Native windows application, minimal dependencies and dlls

## Roadmap
- More options and customization, such as:
  - Customization of mouse controls for actions (click/right click, shift click, etc are all customizable per window)
  - Theming per character
- Adding the ability to create new instances of existing windows
	- Multiple message windows (player chats, party, dm etc)
	- Multiple inventory windows with different views, groups, sorts
- Rework of Character and Skill windows to be a little cleaner
- Plugin capable for new functionality
	- New windows, commands, views
- High DPI support
- Alias system
	- Similar to keybinds, but for the user to create new commands instead of keypresses

## Known Issues
- **bug:** High likelihood of signed vs unsigned display issues
- Clearing or dropping items from Inventory is slow (possibly due to server messaging)
- Fog of war is only partially implemented
- Smoothing is only partially implemented
- Pre-loading/caching images is not implemented
- Autocomplete of commands is not implemented
- Message window filter configuration is not implemented
- Sounds/Music is not implemented

## Building
 1. Open `Crossfire.sln` with Visual Studio 2019 Community Edition
 2. Build Solution

> Note: It is possible that some nuget packages will need to be downloaded to compile this application.
